# Invert4geom

```{include} ../README.md
:start-after: <!-- SPHINX-START-proj-desc -->
:end-before: <!-- SPHINX-END-proj-desc -->
```

```{include} ../README.md
:start-after: <!-- SPHINX-START-badges -->
:end-before: <!-- SPHINX-END-badges -->
```

```{image} figures/cover_fig.png
:alt: cover figure
:width: 400px
:align: center
```

```{admonition} Ready for daily use but still changing.
:class: seealso

This means that we are still adding a lot of new features and sometimes we make changes to the ones we already have while we try to improve the software based on users' experience, test new ideas, make better design decisions, etc. Some of these changes could be **backwards incompatible**. Keep that in mind before you update invert4geom to a new major version (i.e. from `v1.0.0` to `v2.0.0`).
```

```{include} ../README.md
:start-after: <!-- SPHINX-START-long-desc -->
:end-before: <!-- SPHINX-END-long-desc -->
```

```{admonition} How to contribute
:class: seealso

I really welcome all forms of contribution! If you have any questions, comments or suggestions, please open a [discussion](https://github.com/mdtanker/invert4geom/discussions/new/choose) or [issue (feature request)](https://github.com/mdtanker/invert4geom/issues/new/choose) on the [GitHub page](https://github.com/mdtanker/invert4geom/)!

Also, please feel free to share how you're using Invert4Geom, I'd love to know.

Please, read our [Contributor Guide](https://invert4geom.readthedocs.io/en/latest/contributing.html) to learn
how you can contribute to the project.
```

```{note}
*Many parts of this documentation was adapted from the* [Fatiando project](https://www.fatiando.org/).
```

```{toctree}
:maxdepth: 1
:hidden:
overview
install
gallery/index.md
user_guide/index.md
```

```{toctree}
:maxdepth: 2
:hidden:
:caption: 📖 Reference documentation
autoapi/invert4geom/index
citing.md
changelog.md
references.rst
```

```{toctree}
:maxdepth: 1
:hidden:
:caption: ℹ️ Other resources
contributing.md
Source code on GitHub <https://github.com/mdtanker/invert4geom>
```


::::{grid} 2
:::{grid-item-card} {octicon}`rocket` Getting started?
:text-align: center
New to Invert4geom? Start here!
```{button-ref} overview
    :click-parent:
    :color: primary
    :outline:
    :expand:
```
:::

:::{grid-item-card} {octicon}`comment-discussion` Need help?
:text-align: center
Start a discussion on GitHub!
```{button-link} https://github.com/mdtanker/invert4geom/discussions
    :click-parent:
    :color: primary
    :outline:
    :expand:
    Discussions
```
:::

:::{grid-item-card} {octicon}`file-badge` Reference documentation
:text-align: center
A list of modules and functions
```{button-ref} autoapi/invert4geom/index
    :click-parent:
    :color: primary
    :outline:
    :expand:
```
:::

:::{grid-item-card} {octicon}`bookmark` Using Invert4geom for research?
:text-align: center
Citations help support our work
```{button-ref} citing
    :click-parent:
    :color: primary
    :outline:
    :expand:
```
:::
::::